Debian Bug report logs - #716779
apt-xapian-index: xdg.Exceptions.ParsingError from cron.weekly/apt-xapian-index

version graph

Package: app-install-data; Maintainer for app-install-data is Julian Andres Klode <jak@debian.org>; Source for app-install-data is src:app-install-data.

Reported by: Tim Marston <tim@ed.am>

Date: Fri, 12 Jul 2013 16:15:02 UTC

Severity: normal

Tags: confirmed, patch

Merged with 700810, 720138

Found in version app-install-data/2012.06.16.1

Reply or subscribe to this bug.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Enrico Zini <enrico@debian.org>:
Bug#716779; Package apt-xapian-index. (Fri, 12 Jul 2013 16:15:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Tim Marston <tim@ed.am>:
New Bug report received and forwarded. Copy sent to Enrico Zini <enrico@debian.org>. (Fri, 12 Jul 2013 16:15:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Tim Marston <tim@ed.am>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: apt-xapian-index: xdg.Exceptions.ParsingError from cron.weekly/apt-xapian-index
Date: Fri, 12 Jul 2013 17:12:06 +0100
Package: apt-xapian-index
Version: 0.45
Severity: normal

Dear Maintainer,

I get the following email from cron every week (on two different machines, but
the same error, exactly):

/etc/cron.weekly/apt-xapian-index:
Traceback (most recent call last):
  File "/usr/sbin/update-apt-xapian-index", line 97, in <module>
    if not indexer.setupIndexing(force=opts.force, system=opts.pkgfile is None):
  File "/usr/lib/pymodules/python2.7/axi/indexer.py", line 518, in setupIndexing
    addon.obj.init(dict(values=self.values), self.progress)
  File "/usr/share/apt-xapian-index/plugins/app-install.py", line 142, in init
    entry = DesktopEntry(os.path.join(APPINSTALLDIR, f))
  File "/usr/lib/python2.7/dist-packages/xdg/DesktopEntry.py", line 33, in __init__
    self.parse(filename)
  File "/usr/lib/python2.7/dist-packages/xdg/DesktopEntry.py", line 42, in parse
    IniFile.parse(self, file, ["Desktop Entry", "KDE Desktop Entry"])
  File "/usr/lib/python2.7/dist-packages/xdg/IniFile.py", line 81, in parse
    raise ParsingError("Invalid line: " + line, filename)
xdg.Exceptions.ParsingError: ParsingError in file '/usr/share/app-install/desktop/spout.desktop', Invalid line: Categories:Application:Game:ArcadeGame
run-parts: /etc/cron.weekly/apt-xapian-index exited with return code 1

After looking at bug #592323 (which appears to be a different problem), I tried
running the following as root:

  # /usr/sbin/update-apt-xapian-index --update --quiet

And I get the exact same error.  I also tried running:

  # update-apt-xapian-index --force

But I get the exact same error again.

If it helps at all, the first time I received this error in an email from cron
was on the 3rd July (from a machine that is always on).  The previous apt
update had been on 1st July and had done the following:

Start-Date: 2013-07-01  09:03:30
Install: ant:amd64 (1.9.1-1, automatic), libcolord-gtk1:amd64 (0.1.25-1, automatic), libcolorhug1:amd64 (1.0.1-1, automatic), libjson-glib-1.0-common:amd64 (
0.16.0-1, automatic), ant-optional:amd64 (1.9.1-1, automatic), libmsv-java:amd64 (2009.1+dfsg1-4, automatic), librelaxng-datatype-java:amd64 (1.0+ds1-3, auto
matic), init-system-helpers:amd64 (1.4, automatic), libisorelax-java:amd64 (20041111-8, automatic)
Upgrade: gnome-packagekit-data:amd64 (3.8.2-3, 3.8.2-4), aptdaemon-data:amd64 (0.45-2, 0.45-3), libpangomm-1.4-1:amd64 (2.28.4-1, 2.34.0-1), libstdc++-4.8-dev:amd64 (4.8.1-4, 4.8.1-5), linux-headers-3.9-1-amd64:amd64 (3.9.6-1, 3.9.8-1), libasan0:amd64 (4.8.1-4, 4.8.1-5), libglu1-mesa-dev:amd64 (8.0.5-7, 9.0.0-1), xdg-user-dirs:amd64 (0.14-1, 0.15-1), emacs23-bin-common:amd64 (23.4+1-4, 23.4+1-4.1), libquadmath0:amd64 (4.8.1-4, 4.8.1-5), gcc-4.8-base:amd64 (4.8.1-4, 4.8.1-5), gcc-4.8-base:i386 (4.8.1-4, 4.8.1-5), gvfs-bin:amd64 (1.16.2-5, 1.16.3-1), libxfixes3:amd64 (5.0-4+deb7u1, 5.0.1-1), libxfixes3:i386 (5.0-4+deb7u1, 5.0.1-1), multiarch-support:amd64 (2.17-5, 2.17-7), cups-server-common:amd64 (1.6.2-9, 1.6.2-10), libasound2-data:amd64 (1.0.27.1-1, 1.0.27.1-2), gnome-packagekit:amd64 (3.8.2-3, 3.8.2-4), libgtkmm-2.4-1c2a:amd64 (2.24.2-1, 2.24.4-1), man-db:amd64 (2.6.4-1, 2.6.5-2), libgail18:amd64 (2.24.18-1, 2.24.19-1), lib32gcc1:amd64 (4.8.1-4, 4.8.1-5), libxext6:amd64 (1.
 3.1-2+deb7u1, 1.3.2-1), libxext6:i386 (1.3.1-2+deb7u1, 1.3.2-1), python-socksipy:amd64 (1.0-1, 1.0-2), lib32stdc++6:amd64 (4.8.1-4, 4.8.1-5), libdmapsharing-3.0-2:amd64 (2.9.17-1, 2.9.18-1), libsensors4:amd64 (3.3.3-1, 3.3.4-1), cpp-4.8:amd64 (4.8.1-4, 4.8.1-5), libc6-i686:i386 (2.17-5, 2.17-7), libgomp1:amd64 (4.8.1-4, 4.8.1-5), gir1.2-json-1.0:amd64 (0.14.2-1, 0.16.0-1), libxi6:amd64 (1.6.1-1+deb7u1, 1.7.1.901-1), libxi6:i386 (1.6.1-1+deb7u1, 1.7.1.901-1), libfreerdp1:amd64 (1.0.2-1, 1.0.2-2), pcb-common:amd64 (20110918-7, 20110918-8), p11-kit:amd64 (0.18.3-2, 0.18.4-1), linux-image-3.9-1-amd64:amd64 (3.9.6-1, 3.9.8-1), wireless-regdb:amd64 (2011.04.28-1, 2013.02.13-1), libtsan0:amd64 (4.8.1-4, 4.8.1-5), libfontconfig1:amd64 (2.10.2-1, 2.10.2-2), libfontconfig1:i386 (2.10.2-1, 2.10.2-2), iproute2:amd64 (3.9.0-4, 3.9.0-5), libp11-kit-dev:amd64 (0.18.3-2, 0.18.4-1), libphobos-4.8-dev:amd64 (4.8.1-4, 4.8.1-5), libcups2:amd64 (1.6.2-9, 1.6.2-10), liblog4j1.2-java:amd64 (1.2.17
 -2, 1.2.17-3), cups-daemon:amd64 (1.6.2-9, 1.6.2-10), cryptsetup-bin:amd64 (1.4.3-4, 1.6.1-1), openssh-server:amd64 (6.2p2-4, 6.2p2-5), libqtwebkit4:amd64 (2.2.1-5, 2.2.1-6), libcupsmime1:amd64 (1.6.2-9, 1.6.2-10), cups-client:amd64 (1.6.2-9, 1.6.2-10), python-aptdaemon.gtkwidgets:amd64 (0.45-2, 0.45-3), gnome-packagekit-session:amd64 (3.8.2-3, 3.8.2-4), emacs23-common:amd64 (23.4+1-4, 23.4+1-4.1), gvfs-common:amd64 (1.16.2-5, 1.16.3-1), libc-dev-bin:amd64 (2.17-5, 2.17-7), libgcc1:amd64 (4.8.1-4, 4.8.1-5), libgcc1:i386 (4.8.1-4, 4.8.1-5), libcupsimage2:amd64 (1.6.2-9, 1.6.2-10), fontconfig:amd64 (2.10.2-1, 2.10.2-2), liblouis-data:amd64 (2.5.2-2, 2.5.3-1), gtk2-engines-pixbuf:amd64 (2.24.18-1, 2.24.19-1), libc-bin:amd64 (2.17-5, 2.17-7), libc6:amd64 (2.17-5, 2.17-7), libc6:i386 (2.17-5, 2.17-7), libnuma1:amd64 (2.0.8-2, 2.0.8-3), debhelper:amd64 (9.20130624, 9.20130630), emacs23:amd64 (23.4+1-4, 23.4+1-4.1), gdbserver:amd64 (7.6-3, 7.6-4), libgtk2.0-bin:amd64 (2.24.18-1, 2.
 24.19-1), libasound2-dev:amd64 (1.0.27.1-1, 1.0.27.1-2), cups:amd64 (1.6.2-9, 1.6.2-10), libgtk2.0-common:amd64 (2.24.18-1, 2.24.19-1), libobjc4:amd64 (4.8.1-4, 4.8.1-5), libgcr-3-1:amd64 (3.8.2-3, 3.8.2-4), gvfs-daemons:amd64 (1.16.2-5, 1.16.3-1), libxrender1:amd64 (0.9.7-1+deb7u1, 0.9.8-1), libxrender1:i386 (0.9.7-1+deb7u1, 0.9.8-1), python-aptdaemon.gtk3widgets:amd64 (0.45-2, 0.45-3), fontconfig-config:amd64 (2.10.2-1, 2.10.2-2), curl:amd64 (7.31.0-1, 7.31.0-2), patch:amd64 (2.6.1-3, 2.7.1-3), gir1.2-gtk-2.0:amd64 (2.24.18-1, 2.24.19-1), libdjvulibre-text:amd64 (3.5.25.3-3, 3.5.25.4-1), g++:amd64 (4.8.1-1, 4.8.1-2), libgd3:amd64 (2.1.0~rc2-2, 2.1.0-2), libgd3:i386 (2.1.0~rc2-2, 2.1.0-2), gir1.2-gcr-3:amd64 (3.8.2-3, 3.8.2-4), libcryptsetup4:amd64 (1.4.3-4, 1.6.1-1), liblouis2:amd64 (2.5.2-2, 2.5.3-1), libatomic1:amd64 (4.8.1-4, 4.8.1-5), libgtkspell3-3-0:amd64 (3.0.2-2, 3.0.3-1), gnome-chess:amd64 (3.8.2-1, 3.8.3-1), libfreerdp-plugins-standard:amd64 (1.0.2-1, 1.0.2-2), l
 ibsndfile1:amd64 (1.0.25-5, 1.0.25-6), libsndfile1:i386 (1.0.25-5, 1.0.25-6), glibc-doc:amd64 (2.17-5, 2.17-7), libv4lconvert0:amd64 (0.8.9-3, 0.8.9-4), libv4lconvert0:i386 (0.8.9-3, 0.8.9-4), python-xdg:amd64 (0.19-5, 0.25-3), g++-4.8:amd64 (4.8.1-4, 4.8.1-5), gvfs:amd64 (1.16.2-5, 1.16.3-1), mtpfs:amd64 (1.1-4, 1.1-4.1), libxi-dev:amd64 (1.6.1-1+deb7u1, 1.7.1.901-1), gdc-4.8:amd64 (4.8.1-4, 4.8.1-5), libv4l-0:amd64 (0.8.9-3, 0.8.9-4), libv4l-0:i386 (0.8.9-3, 0.8.9-4), libintl-perl:amd64 (1.20-1, 1.23-1), libexempi3:amd64 (2.2.0-1, 2.2.1-1), dictionaries-common:amd64 (1.20.1, 1.20.2), gcc:amd64 (4.8.1-1, 4.8.1-2), lshw:amd64 (02.16-1, 02.16-2), gcr:amd64 (3.8.2-3, 3.8.2-4), logrotate:amd64 (3.8.3-5, 3.8.5-1), cups-bsd:amd64 (1.6.2-9, 1.6.2-10), gdb:amd64 (7.6-3, 7.6-4), gdc:amd64 (4.8.1-1, 4.8.1-2), openssh-client:amd64 (6.2p2-4, 6.2p2-5), libgcc-4.8-dev:amd64 (4.8.1-4, 4.8.1-5), lm-sensors:amd64 (3.3.3-1, 3.3.4-1), libgck-1-0:amd64 (3.8.2-3, 3.8.2-4), cpp:amd64 (4.8.1-1, 4
 .8.1-2), libgsf-1-common:amd64 (1.14.27-1, 1.14.27-2), libxfixes-dev:amd64 (5.0-4+deb7u1, 5.0.1-1), python-aptdaemon-gtk:amd64 (0.45-2, 0.45-3), gvfs-backends:amd64 (1.16.2-5, 1.16.3-1), help2man:amd64 (1.43.2, 1.43.3), gcc-4.8:amd64 (4.8.1-4, 4.8.1-5), libp11-kit0:amd64 (0.18.3-2, 0.18.4-1), libgtk2.0-0:amd64 (2.24.18-1, 2.24.19-1), libasound2:amd64 (1.0.27.1-1, 1.0.27.1-2), libasound2:i386 (1.0.27.1-1, 1.0.27.1-2), libcolord1:amd64 (0.1.21-4, 1.0.1-1), libcupscgi1:amd64 (1.6.2-9, 1.6.2-10), libjson-glib-1.0-0:amd64 (0.14.2-1, 0.16.0-1), libatkmm-1.6-1:amd64 (2.22.7-1, 2.22.7-2), python-aptdaemon:amd64 (0.45-2, 0.45-3), libxrandr-dev:amd64 (1.3.2-2+deb7u1, 1.4.1-1), libxext-dev:amd64 (1.3.1-2+deb7u1, 1.3.2-1), aptdaemon:amd64 (0.45-2, 0.45-3), libgsf-1-114:amd64 (1.14.27-1, 1.14.27-2), gnome-color-manager:amd64 (3.4.2-1, 3.8.2-1), libcupsppdc1:amd64 (1.6.2-9, 1.6.2-10), libcurl3:amd64 (7.31.0-1, 7.31.0-2), pcb-gtk:amd64 (20110918-7+b1, 20110918-8), cvs:amd64 (1.12.13+real-9
 , 1.12.13+real-10), tk8.5:amd64 (8.5.11-2, 8.5.14-2), libgfortran3:amd64 (4.8.1-4, 4.8.1-5), tcl8.5:amd64 (8.5.11-2, 8.5.14-2), libxrender-dev:amd64 (0.9.7-1+deb7u1, 0.9.8-1), libdom4j-java:amd64 (1.6.1+dfsg.2-6, 1.6.1+dfsg.3-2), libgcj-common:amd64 (4.6.4-1, 4.6.4-2), libc6-i386:amd64 (2.17-5, 2.17-7), libappstream0:amd64 (0.2.0-2, 0.3.1-2), libcurl4-gnutls-dev:amd64 (7.31.0-1, 7.31.0-2), cups-common:amd64 (1.6.2-9, 1.6.2-10), libgcj-bc:amd64 (4.8.1-1, 4.8.1-2), libxinerama1:amd64 (1.1.2-1+deb7u1, 1.1.3-1), pcb:amd64 (20110918-7, 20110918-8), libsasl2-modules:amd64 (2.1.25.dfsg1-8, 2.1.25.dfsg1-11), libxinerama-dev:amd64 (1.1.2-1+deb7u1, 1.1.3-1), cryptsetup:amd64 (1.4.3-4, 1.6.1-1), liblua5.2-0:amd64 (5.2.1-3, 5.2.2-1), python-louis:amd64 (2.5.2-2, 2.5.3-1), libsasl2-2:amd64 (2.1.25.dfsg1-8, 2.1.25.dfsg1-11), gnome-search-tool:amd64 (3.4.0-2+b1, 3.6.0-1), gvfs-libs:amd64 (1.16.2-5, 1.16.3-1), gir1.2-gck-1:amd64 (3.8.2-3, 3.8.2-4), xdg-user-dirs-gtk:amd64 (0.9-1, 0.10-1), c
 olord:amd64 (0.1.21-4, 1.0.1-1), gcj-4.8-jre-lib:amd64 (4.8.1-4, 4.8.1-5), xfce4-terminal:amd64 (0.6.2-1, 0.6.2-3), cups-ppdc:amd64 (1.6.2-9, 1.6.2-10), libobjc-4.8-dev:amd64 (4.8.1-4, 4.8.1-5), libc6-dbg:amd64 (2.17-5, 2.17-7), linux-libc-dev:amd64 (3.9.6-1, 3.9.8-1), iproute:amd64 (3.9.0-4, 3.9.0-5), libdjvulibre21:amd64 (3.5.25.3-3, 3.5.25.4-1), libgcr-base-3-1:amd64 (3.8.2-3, 3.8.2-4), libfontconfig1-dev:amd64 (2.10.2-1, 2.10.2-2), libstdc++6:amd64 (4.8.1-4, 4.8.1-5), libstdc++6:i386 (4.8.1-4, 4.8.1-5), libgtk2.0-dev:amd64 (2.24.18-1, 2.24.19-1), libitm1:amd64 (4.8.1-4, 4.8.1-5), locales:amd64 (2.17-5, 2.17-7), libxrandr2:amd64 (1.3.2-2+deb7u1, 1.4.1-1), libxrandr2:i386 (1.3.2-2+deb7u1, 1.4.1-1), libglu1-mesa:amd64 (8.0.5-7, 9.0.0-1), libc6-dev:amd64 (2.17-5, 2.17-7), libgcr-3-common:amd64 (3.8.2-3, 3.8.2-4), libgcj14:amd64 (4.8.1-4, 4.8.1-5), libcurl3-gnutls:amd64 (7.31.0-1, 7.31.0-2), libgcr-ui-3-1:amd64 (3.8.2-3, 3.8.2-4), libgail-common:amd64 (2.24.18-1, 2.24.19-1), 
 rsyslog:amd64 (7.4.1-1, 7.4.1-3), linux-headers-3.9-1-common:amd64 (3.9.6-1, 3.9.8-1), appstream-index:amd64 (0.2.0-2, 0.3.1-2)
Remove: libcommons-codec-java:amd64 (1.8-1), libjaxme-java:amd64 (0.5.2+dfsg-6), libbackport-util-concurrent-java:amd64 (3.1-3)
End-Date: 2013-07-01  09:11:52

-- System Information:
Debian Release: jessie/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)
Foreign Architectures: i386

Kernel: Linux 3.9-1-amd64 (SMP w/4 CPU cores)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages apt-xapian-index depends on:
ii  python          2.7.5-2
ii  python-apt      0.8.9.1
ii  python-debian   0.1.21+nmu2
ii  python-support  1.0.15
ii  python-xapian   1.2.15-4

apt-xapian-index recommends no packages.

Versions of packages apt-xapian-index suggests:
ii  app-install-data  2012.06.16.1
ii  python-xdg        0.25-3

-- no debconf information



Information forwarded to debian-bugs-dist@lists.debian.org, Enrico Zini <enrico@debian.org>:
Bug#716779; Package apt-xapian-index. (Wed, 17 Jul 2013 12:09:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Ólafur Jens Sigurðsson" <ojsbug@gmail.com>:
Extra info received and forwarded to list. Copy sent to Enrico Zini <enrico@debian.org>. (Wed, 17 Jul 2013 12:09:04 GMT) Full text and rfc822 format available.

Message #10 received at 716779@bugs.debian.org (full text, mbox):

From: "Ólafur Jens Sigurðsson" <ojsbug@gmail.com>
To: 716779@bugs.debian.org
Subject: confirm bug
Date: Wed, 17 Jul 2013 12:06:26 +0000
I confirm this bug, I get the same message from cron.

Cheers, Óli



Bug reassigned from package 'apt-xapian-index' to 'app-install-data'. Request was from "Ólafur Jens Sigurðsson" <ojsbug@gmail.com> to control@bugs.debian.org. (Wed, 17 Jul 2013 12:36:04 GMT) Full text and rfc822 format available.

No longer marked as found in versions apt-xapian-index/0.45. Request was from "Ólafur Jens Sigurðsson" <ojsbug@gmail.com> to control@bugs.debian.org. (Wed, 17 Jul 2013 12:36:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Julian Andres Klode <jak@debian.org>:
Bug#716779; Package app-install-data. (Wed, 17 Jul 2013 13:00:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Ólafur Jens Sigurðsson" <ojsbug@gmail.com>:
Extra info received and forwarded to list. Copy sent to Julian Andres Klode <jak@debian.org>. (Wed, 17 Jul 2013 13:00:13 GMT) Full text and rfc822 format available.

Message #19 received at 716779@bugs.debian.org (full text, mbox):

From: "Ólafur Jens Sigurðsson" <ojsbug@gmail.com>
To: 716779@bugs.debian.org
Subject: reassigned
Date: Wed, 17 Jul 2013 12:55:59 +0000
Reassigned this bug to app-install-data since it is caused by a format
issue of the Categories:Application:Game:ArcadeGame line in
/usr/share/app-install/desktop/spout.desktop file. The line should read
Categories=Application:Game:ArcadeGame

Cheers, Óli



Information forwarded to debian-bugs-dist@lists.debian.org, Julian Andres Klode <jak@debian.org>:
Bug#716779; Package app-install-data. (Tue, 23 Jul 2013 19:45:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raf Czlonka <rafal.czlonka@gmail.com>:
Extra info received and forwarded to list. Copy sent to Julian Andres Klode <jak@debian.org>. (Tue, 23 Jul 2013 19:45:08 GMT) Full text and rfc822 format available.

Message #24 received at 716779@bugs.debian.org (full text, mbox):

From: Raf Czlonka <rafal.czlonka@gmail.com>
To: Debian Bug Tracking System <716779@bugs.debian.org>
Subject: Re: apt-xapian-index: xdg.Exceptions.ParsingError from cron.weekly/apt-xapian-index
Date: Tue, 23 Jul 2013 20:44:11 +0100
Package: app-install-data
Version: 2012.06.16.1
Followup-For: Bug #716779

The line should read:

Categories=Application;Game;ArcadeGame

and *not*

Categories=Application:Game:ArcadeGame

Categories are semicolon, not colon, -separated.

Regards,

Raf

-- System Information:
Debian Release: jessie/sid
  APT prefers unstable
  APT policy: (999, 'unstable'), (1, 'experimental')
Architecture: powerpc (ppc)

Kernel: Linux 3.2.0-4-powerpc
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

-- no debconf information



Added blocking bug(s) of 716779: 556938 Request was from Juhani Numminen <juhaninumminen0@gmail.com> to control@bugs.debian.org. (Sun, 11 Aug 2013 07:39:07 GMT) Full text and rfc822 format available.

Added tag(s) confirmed and patch. Request was from Juhani Numminen <juhaninumminen0@gmail.com> to control@bugs.debian.org. (Sun, 11 Aug 2013 07:39:09 GMT) Full text and rfc822 format available.

Merged 700810 716779 Request was from Juhani Numminen <juhaninumminen0@gmail.com> to control@bugs.debian.org. (Sun, 11 Aug 2013 07:39:10 GMT) Full text and rfc822 format available.

Merged 700810 716779 720138 Request was from Vincent Cheng <vincentc1208@gmail.com> to control@bugs.debian.org. (Mon, 19 Aug 2013 08:27:23 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 19:23:05 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.